﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using ValutaClassLibrary;

namespace ValutaWcfService
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
    public class ValutaService : IValutaService
    {
        // KlasseNiveau - "singleton"
        static List<Valuta> valutaListe;
        static ValutaService()
        {
            valutaListe = new List<Valuta>();
            valutaListe.Add(new Valuta("EUR", "Euro", 745.9900));
            valutaListe.Add(new Valuta("DKK", "Danmark", 100.0000));
        }

        private List<ValutaBeloeb> valutaBeloebene = new List<ValutaBeloeb>();
        public ValutaService()
        {
        }

        private Valuta FindValuta(string ISO)
        {
//            Valuta fundetValuta;

//            fundetValuta = new Valuta("EUR", "Euro", 745.9900);
            foreach (Valuta v in valutaListe)
            {
                if (v.ISO == ISO)
                    return v;
            }
//            return fundetValuta;
            return null;
        }

        public double Omregn2Euro(double beloeb)
        {
            double euro;
            double kurs = 745.9900;
            euro = beloeb/(kurs/100);
            return euro;
        }


        public double HentKurs(string ISO)
        {
            Valuta v = FindValuta(ISO);
            if (v != null)
                return v.Kurs;
            else
                return 0;
        }
        public Valuta[] HentValutaArray()
        {
            return valutaListe.ToArray();
        }


        public ValutaBeloeb Omregn(string Fra_ISO, double beloeb, string Til_ISO)
        {
            ValutaBeloeb vbel = new ValutaBeloeb();
            vbel.Fra_ISO = Fra_ISO;
            vbel.Fra_Beloeb = beloeb;
            vbel.Til_ISO = Til_ISO;

            double Fra_Kurs = HentKurs(Fra_ISO);
            double Til_Kurs = HentKurs(Til_ISO);

            vbel.Til_Beloeb = beloeb * (Fra_Kurs / Til_Kurs);
            valutaBeloebene.Add(vbel);
            return vbel;
        }


        public ValutaBeloeb[] HentOmregnede()
        {
            return valutaBeloebene.ToArray();
        }
    }
}
